Imports System.IO
Imports System.Net
Imports System.Net.Security
Imports System.Security.Cryptography.X509Certificates
Imports System.Web.Script.Serialization

Partial Class Examples_StandardIntegratedUserVerificationExampleVBDotNET
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        Try
            If Not IsPostBack Then
                lblIPAddress.Text += Request.UserHostAddress
            End If
        Catch ex As Exception

        End Try

        If ServicePointManager.ServerCertificateValidationCallback Is Nothing Then
            ServicePointManager.ServerCertificateValidationCallback =
                Function(ByVal objSender As Object, ByVal certificate As X509Certificate, ByVal chain As X509Chain, ByVal errors As SslPolicyErrors) True
        End If
    End Sub

    Protected Sub btnSignIn_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim responseText As String = ""
        Try
            Dim request = BuildPostRequest("https://e5.onthehub.com/WebStore/Security/AuthenticateUser.ashx")
            Using response = request.GetResponse()
                Dim reader = New StreamReader(response.GetResponseStream())
                responseText = reader.ReadToEnd()
            End Using
        Catch webEx As WebException
            If webEx.Response Is Nothing Then
                responseText = "Message: " & webEx.Message
            Else
                responseText = (CType(webEx.Response, HttpWebResponse)).StatusDescription
            End If

        End Try

        txtResponse.Text = responseText
        If chkDoRedirect.Checked AndAlso (responseText.StartsWith("https://") OrElse responseText.StartsWith("http://")) Then
            Response.Redirect(responseText, True)
        End If
    End Sub

    Private Function BuildPostRequest(ByVal url As String) As WebRequest
        Dim httpWebRequest = WebRequest.Create(url)
        httpWebRequest.ContentType = "application/json"
        httpWebRequest.Method = "POST"
        Dim parameterDictionary = BuildParameterDictionary()
        Using streamWriter = New StreamWriter(httpWebRequest.GetRequestStream())
            Dim json = New JavaScriptSerializer().Serialize(parameterDictionary)
            streamWriter.Write(json)
        End Using

        Return httpWebRequest
    End Function

    Private Function BuildParameterDictionary() As Dictionary(Of String, Object)
        Dim dict = New Dictionary(Of String, Object) From {{"username", txtUsername.Text.Trim()}, {"account", txtAccount.Text.Trim()}, {"email", txtEmailAddress.Text.Trim()}, {"key", txtKey.Text.Trim()}}
        Dim firstName = txtFirstName.Text.Trim()
        If Not String.IsNullOrEmpty(firstName) Then
            dict.Add("first_name", firstName)
        End If

        Dim lastName = txtLastName.Text.Trim()
        If Not String.IsNullOrEmpty(lastName) Then
            dict.Add("last_name", lastName)
        End If

        Dim shopperIp = txtShopperIP.Text.Trim()
        If Not String.IsNullOrEmpty(shopperIp) Then
            dict.Add("shopper_ip", shopperIp)
        End If

        Dim academicStatuses = txtAcademicStatuses.Text.Trim().Split(","c)
        dict.Add("academic_statuses", academicStatuses)
        Return dict
    End Function
End Class
